GETGRENT(3)

NAME
getgrent, setgrent, endgrent - get group file entry

SYNOPSIS
#include <sys/types.h>
#include <grp.h>

struct group *getgrent(void);

void setgrent(void);

void endgrent(void);

DESCRIPTION
The getgrent() function returns a pointer to a structure containing the broken-out fields of a record in the group database (e.g., the local group file /etc/group, NIS, and LDAP). The first time it is called it returns the first entry; thereafter, it returns successive entries.

The setgrent() function rewinds to the beginning of the group database, to allow repeated scans.

The endgrent() function is used to close the group database after all processing has been performed.

The group structure is defined in <grp.h> as follows:

    struct group {
        char   *gr_name;       /* group name */
        char   *gr_passwd;     /* group password */
        gid_t   gr_gid;        /* group ID */
        char  **gr_mem;        /* group members */
    };

RETURN VALUE
The getgrent() function returns a pointer to a group structure, or NULL if there are no more entries or an error occurs.

Upon error, errno may be set. If one wants to check errno after the call, it should be set to zero before the call.

ERRORS

EINTR
    A signal was caught.

EIO I/O error.

EMFILE
    The calling process already has too many open files.

ENFILE
    Too many open files in the system.

ENOMEM
    Insufficient memory to allocate group information structure.

ERANGE
    Insufficient buffer space supplied.

FILES

/etc/group
    local group database file

CONFORMING TO
SVID 3, 4.3BSD, POSIX 1003.1-2003.

SEE ALSO
fgetgrent(3), getgrent_r(3), getgrgid(3), getgrnam(3), putgrent(3)